#include<stdio.h>
#include "mpi.h"
#define MAX 64

void prefixsum(int *x, int r){
  int j;
  MPI_Status st;
  int xin=*x,xaux;  

  j = 1;
  while(j<MAX){
    int i;
/*      printf("<%d:%d:%d:%d>\n",j,r,xin,r); */
    if ((r+j)<MAX) MPI_Send(&xin,1,MPI_INT,r+j,0,MPI_COMM_WORLD);
    if ((r-j)>=0){
      MPI_Recv(&xaux,1,MPI_INT,r-j,0,MPI_COMM_WORLD,&st);
      xin+=xaux;
    }
    j<<=1;
  }
  *x=xin;
}

int main(int argc,char *argv[]){
  int i,sz,rank;
  int x,xsend[MAX];

  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&sz);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);

  if (MAX!=sz){
    printf("proc %d:I should be run with %d processes\n",rank,MAX);
    MPI_Finalize();
    exit(-1);
  }
  if (0==rank){
    FILE *fp=fopen(argv[1],"r");
    for (i=0;i<MAX;i++){
      fscanf(fp,"%d",&xsend[i]);
/*        printf(":0:%d:0:\n",xsend[i]); */
    }
    fclose(fp);

    MPI_Scatter(xsend,1,MPI_INT,&x,1,MPI_INT,0,MPI_COMM_WORLD);
    
    prefixsum(&x,rank);

    MPI_Gather(&x,1,MPI_INT,xsend,1,MPI_INT,0,MPI_COMM_WORLD);

    for (i=0;i<MAX;i++)
      printf("%d\n",xsend[i]);
  }
  else {
    MPI_Scatter(xsend,1,MPI_INT,&x,1,MPI_INT,0,MPI_COMM_WORLD);

    prefixsum(&x,rank);

    MPI_Gather(&x,1,MPI_INT,xsend,1,MPI_INT,0,MPI_COMM_WORLD);
  }
  MPI_Finalize();
  return 0;
}

